Jupiter - Zadanie #1705
Dodanie operacji do zarzadzania strukturg na drzewie
2017-06-01 09:18 - Michat Komar

Status: Testowanie Start date: 2017-06-08
Priority: Normalny Due date: 2017-06-08
Assignee: tukasz Waskiewicz % Done: 100%
Category: ui Estimated time: 0.00 hour
Target version: 0.3

Developer: tukasz Waskiewicz Tester: Jarostaw Bgbel
Description

Nalezy dodaé akcje pozwalajgce na przenoszenie elementdéw na drzewie.
Nalezy udostepnic¢ 2 opcje :

1. Przenoszenie elementu jako dziecko wskazanego elementu

2. Przenoszenie dzieci

W przypadku przenoszenia dzieci, uzytkownik powinien mie¢ mozliwosé$ wskazania, ktére dzieci chce przenie$¢ (oraz oczywiscie
wybor elementu docelowego). Gdy wybrane sg wszystkie dzieci, powinna istnie¢ mozliwo$¢ oznaczenie flagi "Usun rodzica", co
spowoduje automatyczne usuniecie rodzica przenoszonych dzieci.

Doda¢ czytanie websocketa o zmianach struktury, gdy zmieni sie struktura jednego z wyswietlanych elementéw, nalezy go
przenie$é na dobre miejsce w drzewie - do zastanowienia sie jak doktadnie ma to dziataé¢

Related issues:
Follows Jupiter - Zadanie # 1560: Oprogramowanie drzewa publikacji Rozwigzany 2017-02-09
Follows Jupiter - Zadanie # 1726: Obstuga operacji na strukturze Rozwigzany 2017-06-07

Associated revisions

Revision 1df5b592 - 2017-07-17 14:06 - Monika Maksymiuk

refs #1705. Nie rozwijanie ostatniego node, brak expandera przy artykutach

Revision 9369bc87 - 2017-11-15 10:51 - Lukasz Waskiewicz

refs #1705 Ul zarzadzanie strukturg

Revision 0139071c - 2017-11-17 12:35 - Lukasz Waskiewicz

refs #1705 Ul zarzadzanie struktura, dialog-tree

Revision 0946ae8e - 2017-11-17 12:35 - Lukasz Waskiewicz

refs #1705 Ul zarzadzanie struktura, ograniczenie wybierania

Revision ea4689ca - 2017-11-17 12:35 - Lukasz Waskiewicz

refs #1705 Ul zarzadzanie strukturg, dostosowanie pod przenoszenie

dzieci
Revision b0aa6af6 - 2017-11-17 12:43 - Lukasz Waskiewicz

refs #1705 Ul zarzadzanie struktura, ttumaczenia

Revision ¢c2300878 - 2017-11-17 15:04 - Lukasz Waskiewicz

refs #1705 Ul zarzagdzanie strukturg, wotanie backendu

Revision d1dd18ad - 2017-11-28 13:27 - Lukasz Waskiewicz

refs #1705 poprawki context menu

Revision 1253578d - 2018-01-31 07:35 - Lukasz Waskiewicz

refs #1705 poprawki modyfikacji struktury

Revision da435b66 - 2018-01-31 10:45 - Lukasz Waskiewicz

refs #1705 poprawka zaznaczania elementu

Revision 9ecf9311 - 2018-02-06 10:57 - Lukasz Waskiewicz

refs #1705 obstuga sync z infong

Revision d2afb056 - 2018-02-06 12:24 - Lukasz Waskiewicz

refs #1705 poprawa obstugi sync z infong

Revision b378f5a4 - 2018-02-08 10:42 - Lukasz Waskiewicz

refs #1705 obstuga sync z infona, poprawa rozwigzania

Revision 22290243 - 2018-02-14 12:37 - Lukasz Waskiewicz

refs #1705 ukrycie dokumentu w wyszukiwaniu do momentu zaindeksowania

zmiany rodzica

Revision ebeb2545 - 2018-05-16 14:16 - Jarostaw Babel

refs #1705 obstuga sync z infong, poprawka ostatniej poprawki (przywrécenie mozliwosci dodawania czasopisma do bazy danych)

History

#1 - 2017-06-01 09:18 - Michat Komar
- Follows Zadanie #1560: Oprogramowanie drzewa publikacji added

#2 - 2017-06-07 08:39 - Michat Komar
- Follows Zadanie #1726: Obstuga operacji na strukturze added

#3 - 2017-06-07 08:57 - Michat Komar
- Description updated

#4 - 2017-08-31 08:50 - Michat Komar
- Assignee changed from Monika Maksymiuk to Michat Komar

#5 - 2017-11-06 12:56 - Michat Komar
- Assignee changed from Michat Komar to tukasz Waskiewicz

#6 - 2017-11-28 13:34 - Lukasz Waskiewicz
- Status changed from Nowy to Testowanie

- % Done changed from 0 to 100

- Developer tukasz Waskiewicz added

- Tester Michat Komar added

#7 - 2017-11-28 13:35 - Lukasz Waskiewicz
- Assignee changed from tukasz Waskiewicz to Michat Komar

#8 - 2017-11-30 10:34 - Michat Komar
- Assignee changed from Michat Komar to Jarostaw Bgbel
- Tester Jarostaw Bgbel added

#9 - 2018-01-04 16:30 - Jarostaw Babel

- Status changed from Testowanie to Odpowiedz
- Assignee changed from Jarostaw Babel to tukasz Waskiewicz

Mozna wybrac¢ calg baze danych jako cel dla przenoszonych zasobow

1. kliknij na artykule "Przenie$ dokument"

2. pojawia sie okno wyboru z drzewem

3. zaznacz baze danych i kliknij "Wybierz"

4. Pojawia sie okno "Btad po stronie serwera"

Podwdéjne klikniecie zasobu w oknie wyboru celu przenoszenia powoduje otwarcie podgladu tego zasobu w
gtéwnym oknie aplikacji "po spodem”

Wybranie zasobu w oknie wyboru celu przenoszenia czasem powoduje przewiniecie listy do gory i znikniecie
wybranego elementu z pola widzenia

1. Kliknij "Przenie$ dzieci dokumentu" dla czasopisma "Acta Scientiarum Polonorum. Oeconomiaa" w BazEkon (
http://localhost:4200/editor/document/bwmetal.element.ekon-element-issn-1644-0757/preview)

2. W drzewie wyboru rozwin wezet tego czasopisma

3. Przewin na dét i kliknij na nastepnym czasopismie w drzewie wyboru

4. Lista zostaje przewinigta do géry, a wybrane czasopismo znika na dole

Préba przeniesienia zasobu, ktéry ma btad w danych (nie waliduje sie po otwarciu w Ul) konczy sie
niepowodzeniem bez komunikatu. Jezeli takie dane bedg istnialy w systemie, to przydatby sie komunikat przy
przenoszeniu.

Np. pierwszy artykut z:
BazEkon -> Acta Scientiarum Polonorum. Oeconomiaa -> 9 (2010) -> nr 1
http://localhost:4200/editor/document/bwmetal.element.ekon-element-000171198405/preview

Po przenoszeniu z6tta belka zaznaczajgca edytowany element pozostaje na state przy jednym elemencie
http://localhost:4200/editor/document/bwmeta1.element.ekon-element-issn-1644-0757/preview
http://localhost:4200/editor/document/bwmeta1.element.ekon-element-000171198405/preview

. Przygotowa¢ artykut A i nr N, do ktérego mozna przenies¢ A
. Otworzy¢ edycje elementu X innego niz Ai N

. Rozwing¢ w drzewie rodzica Ai N

. Przenies¢ Ado N

. Poczeka¢ az A pojawi sie w N

. Otworzy¢ edycje elementu Y (innego niz A, N, X)

N o oA WD =

. Belka pozostaje na X

Po przenoszeniu z6tta belka zaznaczajgca edytowany element znika

. Przygotowac artykut A i nr N, do ktérego mozna przenie$¢ A

. Otworzy¢ edycje A

. Przenies¢ Ado N

. Z6Mta belka znika (pojawia sig informacja "dokument zostat zmieniony")
. Otworzy¢ edycje elementu Y (innego niz A, N)

. Brak zo6ttej belki na Y

. Klikng¢ odséwiez przy N,

. belka pojawia sie na A

. klikna¢ edycje Y - belka nadal zostaje na A

© 00N OhWN =

Przy przenoszeniu zasobu w konsoli pojawia sie btad

Btad przetwarzania XML: nie znaleziono gtéwnego elementu
Obszar: http://localhost:8080/api/structure/move/fd6dac44-8422-452f-9b1{-8642b2d0f7c6 ?deleteParent=false
Numer wiersza: 1, kolumna 1:

Nie wida¢, zeby powodowat jakies$ problemy.

Nie mozna przenie$s¢ numeru do rocznika jezeli nie utworzono wolumenu

(niezaleznie od przenoszenia dokumentéw, w ogdle nie mozna dodac bezposrednio numeru do rocznika)
By¢ moze to nie jest btad tylko kwestia konfiguracji hierarchii dla danej bazy i tak ma by¢é?

Np. w BazEkon, czasopismo "Acta Scientiarum Polonorum. Oeconomiaa" nie ma wolumenéw i nie da sie przenosi¢ numeréw miedzy rocznikami tego
czasopisma.

Problemy z aktualizacja drzewa podczas przenoszenia elementéw, nie wiadomo kiedy konczy sie operacja
przenoszenia

Zaraz po wykonaniu akcji przenie$ drzewo jest aktualizowane, ale operacja nadal trwa w backendzie. Przyciski "od$wiez" w drzewie pokazujg aktualny
stan przenoszenia. Uzytkownik w oczekiwaniu na wynik przenoszenia moze zacza¢ klika¢ "odswiez" na weztach drzewa.
Przyktad:

1. Przenie$ artykut A z numeru N1 do numeru N2

2. A pojawia sie w drzewie pod N2 i znika z N1

3. kliknij odéwiez na N1 i N2

4. A pojawia sig¢ z powrotem w N1 i znika z N2

5. Po zakonczeniu przenoszenia, klikniecie odswiez na N1 i N2 wyswietli A prawidtowo w N2

Podobnie, gdy przenosimy z usuwaniem rodzica - po od$wiez rodzica znika skreslenie usuwanego elementu.
Podczas przenoszenia w drzewie moga pojawi¢ sie "kopie" zasobow. Powstaje wtedy efekt "powigzania":
Przyktad:

1. Przenie$¢ artykut A z N1 do N2

2. Poczeka¢ az A pojawi sie w miejscu docelowym N2

3. Po zniknieciu A z N1, od$wiezy¢ N1 (A pojawia sie ponownie)

4. Teraz mamy Aw N1iw N2

5. Po kliknieciu na ktéras$ kopie A zielona belka pojawia sie dla obu kopii

6. Akcje w drzewie sg dublowane dla skopiowanych weztéw (np. rozwiniecie potomkdw)

Przy przenoszeniu elementéw z wieloma potomkami i klikaniu od$wiez elementy pojawiajg sie i znikaja w zaleznos$ci od etapu przenoszenia. Nie
wiadomo, w ktérym momencie konczy sie proces przenoszenia i czy to co widzimy w drzewie to koncowy efekt, czy tymczasowe potozenie weztdéw
zwigzane z od$wiezaniem.

Pojawia sie tez "btgd potaczenia" opisany w #1927, zwigzany z usunieciem elementu, ktéry nadal jest widoczny w drzewie (przez akcje od$wiez).

Jezeli uruchomimy kolejng akcje przenoszenia zanim zakonczy sie poprzednia to od$wiezanie weztéw bedzie tez "psuto” drzewo w okienku, w ktérym
wybieramy cel dla przenoszonych zasobéw.

Jesli poczekamy na zakorczenie przenoszenia przez backend, to opisane problemy nie wystepuja.
http://localhost:8080/api/structure/move/fd6dac44-8422-452f-9b1f-8642b2d0f7c6?deleteParent=false

Na przenoszonych wezlach mozna wywolywac akcje przed zakonczeniem przenoszenia.

Brak oznaczenia i blokowania przenoszonych weztéw powoduje, ze mozna na nich wywotywac kolejne akcje przed zakonczeniem przenoszenia np.:
przenie$, usun, dodaj nowy element. W potaczeniu z akcjg odéwiez pokazujaca czesciowy stan przenoszenia zaczynaja sie pojawiac trudne do
uchwycenia btedy:

m.in. natknatem sie na NPE w:

pl.edu.icm.jupiter.services.storage.hierarchy.HierarchyManagementServicelmpl.getAllowedChild Types(HierarchyManagementServicelmpl.java
:101)

Zdarzyto sie tez usuniecie catego czasopisma podczas usuwania numeru. Stato sie, to na czasopi$mie, ktérego zawarto$¢ wielokrotnie przenositem i
"psutem". Mogta to by¢ moja pomytka, ale wygladato na "skumulowany podczas klikania" problem w Ul (najpierw zostat skreslony usuwany element,
dopiero potem cate drzewo).

Moze tez sie zdarzy¢ puste okno edytora jezeli edytujemy usuwanego rodzica.

Nie opisuje poszczeg6lnych przypadkéw, bo trudno je wytapac¢ i opisa¢. Maja wspdlne zrédto i nie ma sensu ich katalogowac.

Moze przydato by sie blokowanie ekranu aplikacji podczas przenoszenia (wtedy nie mozna nic popsu¢ i wiadomo, kiedy akcja sie zakonczyta)? Moze
wystarczy tylko implementacja #1691: Cache danych tymczasowych (tak jak w #1881)?

Wedlug opisu zadania powinna by¢ mozliwo$¢ wybrania pojedynczych dzieci do przenoszenia, ale by¢ moze
zostato ustalone ustnie, ze tego nie robimy

#10 - 2018-01-30 13:48 - Lukasz Waskiewicz
- Status changed from Odpowied? to W toku

#11 - 2018-02-06 12:46 - Lukasz Waskiewicz
- Status changed from W toku to Testowanie
- Assignee changed from tukasz Waskiewicz to Jarostaw Babel

1. Wybranie zasobu w oknie wyboru celu przenoszenia czasem powoduje przewinigcie listy do gory i znikniecie wybranego elementu z pola
widzenia

nie udato mi sie odtworzy¢

1. Po przenoszeniu z6tta belka zaznaczajgca edytowany element pozostaje na state przy jednym elemencie

wystarczyto otworzy¢ okno w dodatkowym drzewem

1. Nie mozna przenie$¢ numeru do rocznika jezeli nie utworzono wolumenu

jesli konfiguracja hierarchii nie pozwala na dany element w docelowym miejscu to nie mozna go tam przenies¢
1. Wedtug opisu zadania powinna byé mozliwo$é wybrania pojedynczych dzieci do przenoszenia, ale byé moze zostato ustalone ustnie, ze tego nie
robimy
ustalilismy z Michatem, ze w pierwsze kolejnosci przenosimy wszystkie dzieci, ewentualnie pdzniej mieli§my dorobié¢ wybdr
- przenoszone elementy sg wyszarzane i nie powinno byé mozliwos$ci uruchamiania na nich akcji, uruchamianie REST, jak kto$ bedzie chciat

przenie$¢ ponownie element, ktéry przed chwilg byt przenoszony to elementy ostatecznie wyladuje w miejscu z ostatniej operacji przenoszenia

#12 - 2018-02-12 16:21 - Jarostaw Babel
- Status changed from Testowanie to Odpowiedz
- Assignee changed from Jarostaw Babel to tukasz Waskiewicz

- Mozna wybra¢ cata baze danych jako cel dla przenoszonych zasobow
powyzszy problem nadal wystepuje

tukasz Waskiewicz wrote:
1. Wybranie zasobu w oknie wyboru celu przenoszenia czasem powoduje przewiniecie listy do gory i znikniecie wybranego elementu z pola
widzenia

nie udato mi sie odtworzy¢

problem wystepuje w Firefox (w Chrome dziata dobrze)

1. Po przenoszeniu z6tta belka zaznaczajaca edytowany element pozostaje na state przy jednym elemencie
wystarczyto otworzy¢ okno w dodatkowym drzewem

nie rozumiem odpowiedzi, co znaczy "otworzy¢ okno z dodatkowym drzewem"?

- przenoszone elementy sg wyszarzane i nie powinno by¢ moZzliwosci uruchamiania na nich akcji, uruchamianie REST, jak ktos bedzie chciat

przeniesc ponownie element, ktory przed chwilg byt przenoszony to elementy ostatecznie wylgduje w miejscu z ostatniej operacji przenoszenia

nie widze, zeby elementy byly wyszarzane, nadal mozna je usuwaé, edytowac, odswiezac itp. moze cos zle robie po swojej stronie?

#13 - 2018-02-14 12:51 - Lukasz Waskiewicz
- Status changed from OdpowiedZ to Testowanie
- Assignee changed from tukasz Waskiewicz to Jarostaw Babel

1. Wybranie zasobu w oknie wyboru celu przenoszenia czasem powoduje przewiniecie listy do gory i znikniecie wybranego elementu z pola
widzenia
duplikat #1928

1. Po przenoszeniu z6tta belka zaznaczajgca edytowany element pozostaje na state przy jednym elemencie wystarczyto otworzy¢ okno w
dodatkowym drzewem
chodzito mi ze wystarczy otworzy¢ okno przenoszenia, (klikng¢ w context menu przenies...) to juz powodowato problem z drzewem nie byto

koniecznosci przenoszenia dokumentow

1. przenoszenie dokumentow, przenoszone dokumenty sg usuwane z wynikow wyszukania dopdki wynik wyszukania w indeksie nie bedzie

wskazywat ze majg poprawnego rodzica

#14 - 2018-02-15 09:12 - Jarostaw Babel
- Assignee changed from Jarostaw Bagbel to tukasz Waskiewicz

- jest jeszcze drobiazg zwigzany z mozliwo$cig przeniesienia artykutu/zasobu do innej bazy danych - leci btad po stronie serwera

- pierwszy odruch uzytkownika po zleceniu przenoszenia, to klikanie na od$wiez, zeby zobaczy¢ efekt operacji. Klikajac kilka razy od$wiez na
docelowym wezle zaraz po uruchomieniu przenoszenia zasobu mamy taki efekt:
1. nie wida¢ zasobu
2. pojawia sig
3. znika

4. nie wida¢ go az do zakonczenia operacji (ten punkt jest ok)
Mi sie nadal wydaje, ze nie byto by nic ztego w zablokowaniu catego ekranu podczas przenoszenia, a zeby byto super mozna by pokazywacé jakis
progres bar, albo informacje w stylu "przeniesiono X dokumentéw, pozostato Y", bazujac na odpytywaniu Infony. Mysle, ze przenoszenie to jest solidna
porcja przetwarzania i trudno, zeby aplikacja w tym czasie dziatata dobrze.

#15 - 2018-02-16 15:33 - Lukasz Waskiewicz

samo moje ukrywanie to $rednio mozna przy$pieszyé, ono jest zapiete na starcie publikacji, wcze$niej idzie zapis + potwierdzenie i jak tu od$wiezymy

to dostaniemy zas6b, tylko one dziatajg na danych lokalnych i tu nie mozna ukrywaé zasobéw

blokada catego ekranu byta by spoko dla jednego uzytkownika ale jak byto by ich kilku to juz inni by mieli te problemy co my mamy + nasz uzytkownik
mogtbym kliknaé F5 przetadowaé aplikacje i oming¢ ta przestonke

i bedzie tez ten problem dla innych forkflow: przy uruchomieniu procesu publikacji (ten idzie zupetnie async) proces zapisze zas6b do infony, skasuje
CurrentDocument i mamy ten sam problem co teraz (r6znica jest taka ze po starcie publikacji uzytkownik jest w innych ekranach i nie ma drzewa, ale

jak by szybko klikat to mogtby tam dotrze¢ podczas procesu)

jedyne co mozna zrobic¢ to blokowaé czeste od$wiezanie ... ale nie wazne jak to zrobimy dokument przez chwile bedzie w docelowym miejscu
(Current) potem idzie publikacja (tu aktywuje sie moje ukrywanie) i jest kasowanie Current, wiec dokument i tak sie pojawi i zniknie, mozna jak teraz
usuwam dokument z listy wynikéw to zastepowac go jakim$ placeholderem typu "dokument w trakcie modyfikacji" zamiast go usuwac

a jak dokument jest widoczny to mozna go jeszcze po WS prébowaé zamieni¢ ->

jak user ma widoczny dokument a kto$ inny co$ z nim robi to mozna byto by wysta¢ WS informacje ze dokument jest w trakcie publikacji i wszystkie
dokumenty z taka flaga jako$ blokowaé¢

WS = WebSocket
